/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2006-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: test_tex1.c 818 2008-03-18 12:56:15Z hiro $
 */

/* 
 *		㳰˴ؤƥ(1)
 *
 * ڥƥȤŪ
 *
 *  饿㳰롼ưŪ˥ƥȤ롥
 *
 * ڥƥȹܡ
 *
 *	(A) ras_texref_texΥ顼
 *		(A-1) оݥٻ߾
 *		(A-2) оݥΥ㳰롼Ƥʤ
 *	(B) dis_texena_texΥ顼
 *		(B-1) Υ㳰롼Ƥʤ
 *	(C) ras_tex
 *		(C-1) оݥĥ㳰Ĥǡ˵ư
 *		(C-2) оݥǤʤ
 *		(C-3) оݥ㳰ػ
 *	(D) ena_tex
 *		(D-1) 㳰׵᤬ꡤ˵ư
 *		(D-2) 㳰׵᤬ʤ
 *	(E) ǥѥåˤ뵯ư
 *		(E-1) ǥѥåΥ㳰Ĥǥ㳰
 *			  ᤢ
 *	(F) 㳰롼󤫤Υ꥿ˤ뵯ưϢ³ư
 *	(G) 㳰롼󤫤ˤ
 *		(G-1) äƤ
 *		(G-2) 㳰롼Ϣ³ư
 *	(H) 㳰롼¿ŵư
 *	(I) 㳰롼󤫤Υڴ
 *
 * ڻѥ꥽
 *
 *	TASK1: ᥤΥФƥ㳰׵᤹
 *	TASK2: ¾Фƥ㳰׵᤹оݥ
 *	TASK3: 㳰롼Ƥʤ
 *	TASK4: ٻ߾֤Υ
 *
 * ڥƥȥ󥹡
 *
 *	== TASK1ͥ١10==
 *	1:	֤Υå
 *		ref_tex(TSK_SELF, &rtex)
 *		ras_tex(TASK3, 0x0001)		... (A-2)
 *		ras_tex(TASK4, 0x0001)		... (A-1)
 *		ref_tex(TASK3, &rtex)		... (A-2)
 *		ref_tex(TASK4, &rtex)		... (A-1)
 *	2:	ena_tex()					... (D-2)
 *		ref_tex(TSK_SELF, &rtex)
 *	3:	ras_tex(TSK_SELF, 0x0001)	... (C-1)
 *	== TASK1㳰롼1ܡ==
 *	4:	֤Υå
 *	5:	dis_dsp() ... 4Ĥξ֤򤽤줾Ѳ
 *		chg_ipm(TMAX_INTPRI)
 *		ena_tex()
 *		loc_cpu()
 *		꥿
 *	== TASK1³==
 *	6:	äƤ֤Υå	... (G-1)
 *	7:	dis_dsp() ... 3Ĥξ֤򤽤줾Ѳ
 *		chg_ipm(TMIN_INTPRI)
 *		dis_tex()
 *	8:	ras_tex(TASK1, 0x0002)		... (C-3)
 *		ref_tex(TSK_SELF, &rtex)
 *	9:	ena_tex()					... (D-1)
 *	== TASK1㳰롼2ܡ==
 *	10:	֤Υå
 *	11:	ras_tex(TASK1, 0x0001)		... (C-3)
 *		ras_tex(TASK1, 0x0002)		... (C-3)
 *	12:	ena_dsp() ... 3Ĥξ֤򤽤줾Ѳ
 *		chg_ipm(TMAX_INTPRI)
 *		loc_cpu()
 *		꥿					... (F)
 *	== TASK1㳰롼3ܡ==
 *	13:	֤Υå
 *	14:	ena_dsp() ... 3Ĥξ֤򤽤줾Ѳ
 *		chg_ipm(TMAX_INTPRI)
 *		ena_tex()
 *	15: ras_tex(TSK_SELF, 0x0004)	... (H)
 *	== TASK1㳰롼4ܡ==
 *	16:	֤Υå
 *	17:	dis_dsp() ... 3Ĥξ֤򤽤줾Ѳ
 *		chg_ipm(TIPM_ENAALL)
 *		loc_cpu()
 *		꥿
 *	== TASK1㳰롼3³==
 *	18:	äƤ֤Υå	... (G-2)
 *		꥿
 *	== TASK1³==
 *	19:	äƤ֤Υå	... (G-1)
 *	20: ena_dsp()
 *		chg_ipm(TIPM_ENAALL)
 *		rot_rdq(TPRI_SELF)
 *	== TASK2ͥ١10	==
 *	21:	֤Υå
 *	22:	ena_tex()
 *		rot_rdq(TPRI_SELF)
 *	== TASK3ͥ١10	==
 *	23:	֤Υå
 *	24:	ena_tex()
 *	25:	dis_tex()					... (B-1)
 *		ext_tsk()					... (B-1)
 *	== TASK1³==
 *	26: ras_tex(TASK2, 0x0001)		... (C-2)
 *		ref_tex(TASK2, &rtex)
 *	27:	rot_rdq(TPRI_SELF)			... (E-1)
 *	== TASK2㳰롼1ܡ==
 *	28:	֤Υå
 *		꥿
 *	== TASK2³==
 *	29: ras_tex(TSK_SELF, 0x0002)
 *	== TASK2㳰롼2ܡ==
 *	30:	֤Υå
 *	31:	dis_dsp
 *		rot_rdq(TPRI_SELF)
 *	32:	꥿					... (I)
 *	== TASK1³==
 *	33:	꥿ʥλ
 *	== TASK2³==
 *	34:	ƥȽλ
 */

#include <kernel.h>
#include <t_syslog.h>
#include "kernel_cfg.h"
#include "test_lib.h"
#include "test_tex1.h"

void
tex_task1(TEXPTN texptn, intptr_t exinf)
{
	ER		ercd;

	switch (texptn) {
	case 0x0001:
		check_point(4);
		check_state(false, false, TIPM_ENAALL, false, false, true);

		/*
		 *  ǥѥåػߡͥ٥ޥѹ㳰
		 */
		check_point(5);
		ercd = dis_dsp();
		check_ercd(ercd, E_OK);
		ercd = chg_ipm(TMAX_INTPRI);
		check_ercd(ercd, E_OK);
		ercd = ena_tex();
		check_ercd(ercd, E_OK);
		ercd = loc_cpu();
		check_ercd(ercd, E_OK);
		check_state(false, true, TMAX_INTPRI, true, true, false);
		break;

	case 0x0002:
		check_point(10);
		check_state(false, false, TMIN_INTPRI, true, true, true);

		/*
		 *  㳰׵
		 */
		check_point(11);
		ercd = ras_tex(TSK_SELF, 0x0001);
		check_ercd(ercd, E_OK);
		ercd = ras_tex(TSK_SELF, 0x0002);
		check_ercd(ercd, E_OK);

		/*
		 *  ǥѥåġͥ٥ޥѹCPUå
		 */
		check_point(12);
		ercd = ena_dsp();
		check_ercd(ercd, E_OK);
		ercd = chg_ipm(TMAX_INTPRI);
		check_ercd(ercd, E_OK);
		ercd = loc_cpu();
		check_ercd(ercd, E_OK);
		check_state(false, true, TMAX_INTPRI, false, true, true);
		break;

	case 0x0003:
		check_point(13);
		check_state(false, false, TMIN_INTPRI, true, true, true);

		/*
		 *  ǥѥåġͥ٥ޥѹ㳰
		 */
		check_point(14);
		ercd = ena_dsp();
		check_ercd(ercd, E_OK);
		ercd = chg_ipm(TMAX_INTPRI);
		check_ercd(ercd, E_OK);
		ercd = ena_tex();
		check_ercd(ercd, E_OK);
		check_state(false, false, TMAX_INTPRI, false, true, false);

		/*
		 *  㳰׵
		 */
		check_point(15);
		ercd = ras_tex(TSK_SELF, 0x0004);
		/* ǥ㳰롼ư */
		check_ercd(ercd, E_OK);

		/*
		 *  㳰Υ꥿ˤ긵ξ֤äƤ뤳
		 *  å
		 */
		check_point(18);
		check_state(false, false, TMAX_INTPRI, false, true, false);
		break;

	case 0x0004:
		check_point(16);
		check_state(false, false, TMAX_INTPRI, false, true, true);

		/*
		 *  ǥѥåػߡͥ٥ޥѹCPUå
		 */
		check_point(17);
		ercd = dis_dsp();
		check_ercd(ercd, E_OK);
		ercd = chg_ipm(TIPM_ENAALL);
		check_ercd(ercd, E_OK);
		ercd = loc_cpu();
		check_ercd(ercd, E_OK);
		check_state(false, true, TIPM_ENAALL, true, true, true);
		break;

	default:
		check_point(0);
		break;
	}
}

void
task1(intptr_t exinf)
{
	ER		ercd;
	T_RTEX	rtex;

	/*
	 *  ֤Υå
	 */
	check_point(1);
	check_state(false, false, TIPM_ENAALL, false, false, true);
	ercd = ref_tex(TSK_SELF, &rtex);
	check_ercd(ercd, E_OK);
	check_assert((rtex.texstat & TTEX_DIS) != 0);
	check_assert(rtex.pndptn == 0);

	/*
	 *  ras_texΥ顼
	 */
	ercd = ras_tex(TASK3, 0x0001);
	check_ercd(ercd, E_OBJ);
	ercd = ras_tex(TASK4, 0x0001);
	check_ercd(ercd, E_OBJ);

	/*
	 *  ref_texΥ顼
	 */
	ercd = ref_tex(TASK3, &rtex);
	check_ercd(ercd, E_OBJ);
	ercd = ref_tex(TASK4, &rtex);
	check_ercd(ercd, E_OBJ);

	/*
	 *  㳰ε
	 */
	check_point(2);
	ercd = ena_tex();
	check_ercd(ercd, E_OK);
	check_state(false, false, TIPM_ENAALL, false, false, false);
	ercd = ref_tex(TSK_SELF, &rtex);
	check_ercd(ercd, E_OK);
	check_assert((rtex.texstat & TTEX_ENA) != 0);
	check_assert(rtex.pndptn == 0);

	/*
	 *  㳰׵
	 */
	check_point(3);
	ercd = ras_tex(TSK_SELF, 0x0001);
	/* ǥ㳰롼ư */
	check_ercd(ercd, E_OK);

	/*
	 *  㳰Υ꥿ˤ긵ξ֤äƤ뤳Ȥ
	 *  å
	 */
	check_point(6);
	check_state(false, false, TIPM_ENAALL, false, false, false);

	/*
	 *  ǥѥåػߡͥ٥ޥѹ㳰ػ
	 */
	check_point(7);
	ercd = dis_dsp();
	check_ercd(ercd, E_OK);
	ercd = chg_ipm(TMIN_INTPRI);
	check_ercd(ercd, E_OK);
	ercd = dis_tex();
	check_ercd(ercd, E_OK);
	check_state(false, false, TMIN_INTPRI, true, true, true);

	/*
	 *  㳰׵
	 */
	check_point(8);
	ercd = ras_tex(TASK1, 0x0002);
	check_ercd(ercd, E_OK);
	ercd = ref_tex(TSK_SELF, &rtex);
	check_ercd(ercd, E_OK);
	check_assert((rtex.texstat & TTEX_DIS) != 0);
	check_assert(rtex.pndptn == 0x0002);

	/*
	 *  㳰
	 */
	check_point(9);
	ercd = ena_tex();
	/* ǥ㳰롼ư */
	check_ercd(ercd, E_OK);

	/*
	 *  㳰Υ꥿ˤ긵ξ֤äƤ뤳Ȥ
	 *  å
	 */
	check_point(19);
	check_state(false, false, TMIN_INTPRI, true, true, false);

	/*
	 *  2ڤ괹
	 */
	check_point(20);
	ercd = ena_dsp();
	check_ercd(ercd, E_OK);
	ercd = chg_ipm(TIPM_ENAALL);
	check_ercd(ercd, E_OK);
	ercd = rot_rdq(TPRI_SELF);
	/* ¾Υư */
	check_ercd(ercd, E_OK);

	/*
	 *  2Фƥ㳰׵
	 */
	check_point(26);
	ercd = ras_tex(TASK2, 0x0001);
	check_ercd(ercd, E_OK);
	ercd = ref_tex(TASK2, &rtex);
	check_ercd(ercd, E_OK);
	check_assert((rtex.texstat & TTEX_ENA) != 0);
	check_assert(rtex.pndptn == 0x0001);

	/*
	 *  2ڤ괹
	 */
	check_point(27);
	ercd = rot_rdq(TPRI_SELF);
	/* ¾Υư */
	check_ercd(ercd, E_OK);

	/*
	 *  λ
	 */
	check_point(33);
}

void
tex_task2(TEXPTN texptn, intptr_t exinf)
{
	ER		ercd;

	switch (texptn) {
	case 0x0001:
		check_point(28);
		check_state(false, false, TIPM_ENAALL, false, false, true);
		break;

	case 0x0002:
		check_point(30);
		check_state(false, false, TIPM_ENAALL, false, false, true);

		/*
		 *  ǥѥåػߤơڴ׵᤹롥
		 */
		check_point(31);
		ercd = dis_dsp();
		check_ercd(ercd, E_OK);
		ercd = rot_rdq(TPRI_SELF);
		check_ercd(ercd, E_OK);

		/*
		 *  㳰롼󤫤Υ꥿ǡڴȯ
		 *  롥
		 */
		check_point(32);
		break;

	default:
		check_point(0);
		break;
	}
}

void
task2(intptr_t exinf)
{
	ER		ercd;

	/*
	 *  ֤Υå
	 */
	check_point(21);
	check_state(false, false, TIPM_ENAALL, false, false, true);

	/*
	 *  㳰ε
	 */
	check_point(22);
	ercd = ena_tex();
	check_ercd(ercd, E_OK);
	check_state(false, false, TIPM_ENAALL, false, false, false);

	/*
	 *  3ڤ괹
	 */
	ercd = rot_rdq(TPRI_SELF);
	/* ¾Υư */
	check_ercd(ercd, E_OK);

	/*
	 *  㳰׵
	 */
	check_point(29);
	ercd = ras_tex(TSK_SELF, 0x0002);
	/* ǥ㳰롼ư */
	check_ercd(ercd, E_OK);

	/*
	 *  ƥȽλ
	 */
	check_finish(34);
}

void
task3(intptr_t exinf)
{
	ER		ercd;

	/*
	 *  ֤Υå
	 */
	check_point(23);
	check_state(false, false, TIPM_ENAALL, false, false, true);

	/*
	 *  㳰ε
	 */
	check_point(24);
	ercd = ena_tex();
	check_ercd(ercd, E_OBJ);
	check_state(false, false, TIPM_ENAALL, false, false, true);

	/*
	 *  㳰ζػ
	 */
	check_point(25);
	ercd = dis_tex();
	check_ercd(ercd, E_OBJ);
	check_state(false, false, TIPM_ENAALL, false, false, true);

	/*
	 *  λ
	 */
	ercd = ext_tsk();
	check_point(0);
}

void
task4(intptr_t exinf)
{
	check_point(0);
}

void
tex_task4(TEXPTN texptn, intptr_t exinf)
{
	check_point(0);
}
